/*
 * Motocicli SpA noleggia motocicli alla spiaggia di Monterey.
 * Per promuovere la sua attivit durante i giorni della settimana, 
 * il negozio offre sconti considerevoli.
 * Il prezzo per il noleggio e' cosi' calcolato:
 * Per ciclomotori fino a 50cc: 
 *  - giorni lavorativi: 15.00 euro per le prime tre ore, 
 *    2.50 euro per ogni ora successiva 
 *  - giorni fine settimana: 30.00 euro per le prime tre ore, 
 *    7.50 euro per ogni ora successiva
 * Per i motocicli fino a 250cc:
 *  - giorni lavorativi: 25.00 euro per le prime tre ore, 
 *    3.50 euro per ogni ora successiva 
 *  - giorni fine settimana: 35.00 euro per le prime tre ore, 
 *    8.50 euro per ogni ora successiva
 *    
 * Scrivere un'applicazione che calcoli il costo del noleggio dati il
 * tipo di motociclo, il giorno della settimana, e il numero di ore di noleggio.
 * 
 */

import java.util.*;

public class Noleggio {
	
	/* Definizione di costanti corrispondenti ai diversi costi, con nomi
	   significativi, con l'obiettivo di rendere pi leggibile il codice.
	   Notare che le costanti vengono definite all'interno della classe
	   ma esternamente al metodo main */
	public static final double COSTO_BASE_LAVORATIVO_CICLOMOTORE = 15.00;
	public static final double COSTO_ORARIO_LAVORATIVO_CICLOMOTORE = 2.50;
	public static final double COSTO_BASE_WEEKEND_CICLOMOTORE = 30.00;
	public static final double COSTO_ORARIO_WEEKEND_CICLOMOTORE = 7.50;
	
	public static final double COSTO_BASE_LAVORATIVO_MOTOCICLO = 25.00;
	public static final double COSTO_ORARIO_LAVORATIVO_MOTOCICLO = 3.50;
	public static final double COSTO_BASE_WEEKEND_MOTOCICLO = 35.00;
	public static final double COSTO_ORARIO_WEEKEND_MOTOCICLO = 8.50;
	
	/* Definizione di due tipi enumerativi per definire i domini di
	   valori predefiniti per i tipi di motociclo noleggiabili e per
	   l'elenco dei giorni della settimana.
	   Anche in questo caso la definizione  interna alla classe ma
	   esterna al main */ 
	public static enum TipoMotociclo {CICLOMOTORE, MOTOCICLO};
	public static enum Giorno {LUN, MAR, MER, GIO, VEN, SAB, DOM};
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		double costoNoleggio=0; /* inizializzazione non necessaria ma richiesta da Eclipse che
					   altrimenti riporta un warning */
		// acquisizione dei dati
		System.out.print("Inserire il tipo di motociclo desiderato (CICLOMOTORE, MOTOCICLO): ");
		String inputTipoMoto = tastiera.next().toUpperCase(); /* notare la conversione della stringa 
				in maiuscolo per consentire il successivo riconoscimento con uno dei valori 
				ammissibili per il tipo enumerativo TipoMotociclo */
		TipoMotociclo tipoMoto = TipoMotociclo.valueOf(inputTipoMoto); /* istruzione che converte la
				stringa inserita dall'utente, ossia inputTipoMoto, nel corrispondente
				valore del tipo enumerativo TipoMotociclo. Tale valore viene memorizzato nella
				variabile tipoMoto. Il metodo valueOf  un metodo del tipo enumerato che,
				data una stringa come argomento, restituisce il corrispondente valore nel
				dominio del tipo enumerativo. La corrispondenza deve esistere, altrimenti
				viene generato un errore. In questo esercizio assumiamo che l'untente
				inserisca un valore ammissibile. */
		System.out.print("Inserire il giorno di noleggio (LUN, MAR, MER, GIO, VEN, SAB, DOM): ");
		String inputGiorno = tastiera.next().toUpperCase(); /* notare la conversione in maiuscolo
				come per il caso visto per il tipo di motociclo */
		Giorno giorno = Giorno.valueOf(inputGiorno); /* conversione analoga alla precedente, questa
				volta ad opera del tipo enumerativo Giorno che, grazie al metodo valueOf, 
				converte la stringa argomento nel corrispondente valore del dominio del tipo
				Giorno */
		System.out.print("Inserire il numero di ore di noleggio: ");
		int ore = tastiera.nextInt();
		
		// calcolo del costo di noleggio
		switch(tipoMoto){
		case CICLOMOTORE: 
			switch(giorno){
			case LUN:
			case MAR:
			case MER:
			case GIO:
			case VEN: 
				costoNoleggio = COSTO_BASE_LAVORATIVO_CICLOMOTORE;
				if(ore > 3)
					costoNoleggio += COSTO_ORARIO_LAVORATIVO_CICLOMOTORE*(ore-3);
				break;
			case SAB:
			case DOM:
				costoNoleggio = COSTO_BASE_WEEKEND_CICLOMOTORE;
				if(ore > 3)
					costoNoleggio += COSTO_ORARIO_WEEKEND_CICLOMOTORE*(ore-3);
				break;
			}
			break;
		case MOTOCICLO:
			switch(giorno){
			case LUN:
			case MAR:
			case MER:
			case GIO:
			case VEN: 
				costoNoleggio = COSTO_BASE_LAVORATIVO_MOTOCICLO;
				if(ore > 3)
					costoNoleggio += COSTO_ORARIO_LAVORATIVO_MOTOCICLO*(ore-3);
				break;
			case SAB:
			case DOM:
				costoNoleggio = COSTO_BASE_WEEKEND_MOTOCICLO;
				if(ore > 3)
					costoNoleggio += COSTO_ORARIO_WEEKEND_MOTOCICLO*(ore-3);
				break;
			}
			break;
		}
		
		// stampa del costo di noleggio
		System.out.println("Il costo di noleggio e' pari a: "+costoNoleggio+" euro");
		
		tastiera.close();
		
	}
}
